"use strict";

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * EVTJS: JavaScript API Binding for everiToken blockchain
 * 
 * Copyright(C) everiToken core team
 * Under MIT license
 * 
 * This project is based on some projects under MIT license
 * For detail, please visit our github or read README.md for
 * more informatino.
 */

/**
  * represents EvtConfig
  */
var EvtConfig = function EvtConfig() {
    var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    (0, _classCallCheck3.default)(this, EvtConfig);

    // set default endpoint
    /** 
     * @member {Object} endpoint
     */
    this.endpoint = EvtConfig.getTestNetEndpoint();
    // copy user's config
    if (config) {
        (0, _assign2.default)(this, config);
    }
    // fill default endpoint settings
    if (!this.endpoint) this.endpoint = {};
    if (!this.endpoint.port) this.endpoint.port = 8888;
    if (!this.endpoint.protocol) this.endpoint.protocol = "https";
    if (!this.networkTimeout) this.networkTimeout = 15000;
};

/**
 * Get TestNet endpoint for everiToken
 */


EvtConfig.getTestNetEndpoint = function () {
    return (0, _assign2.default)({}, {
        host: "testnet1.everitoken.io",
        port: 443,
        protocol: "https"
    });
};

/**
 * Get LocalNet EndPoint for everiToken
 */
EvtConfig.getLocalNetEndpoint = function () {
    var host = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "127.0.0.1";
    var port = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 8888;

    return (0, _assign2.default)({}, {
        host: host,
        port: port,
        protocol: "http"
    });
};

module.exports = EvtConfig;