"use strict";

var _require = require('./format'),
    encodeGeneratedAddressToBin = _require.encodeGeneratedAddressToBin,
    decodeGeneratedAddressFromBin = _require.decodeGeneratedAddressFromBin,
    encodeGeneratedAddressToJson = _require.encodeGeneratedAddressToJson,
    decodeGeneratedAddressFromJson = _require.decodeGeneratedAddressFromJson;

module.exports = {
  GeneratedAddress: {
    toJSON: encodeGeneratedAddressToJson,
    fromJSON: decodeGeneratedAddressFromJson,
    toBin: encodeGeneratedAddressToBin,
    fromBin: function fromBin(data) {
      var encoding = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "buffer";

      /* Supporting buffer, base64, hex formats */
      if (encoding !== "buffer") {
        data = Buffer.from(data, encoding);
      }
      return decodeGeneratedAddressFromBin(data);
    }
  }
};